
/**
 * Created by IntelliJ IDEA.
 * Author: Alexandre Koubenski
 *
 *   -  -     .
 * :      .
 * :        .
 *
 *  :
 *    -    (n)
 *    -         (n)
 *    -    (n)
 *
 * Date: 10.12.2005
 * Time: 17:39:14
 */
public class KnuthMorrisPratt {

    /**
     *   -  -       ,
     *        
     *      .
     *
     *     -    -1.
     *
     * @param where -  ,   .
     * @param what  - ,  .
     * @return      -    -1
     */
    public static int knuthMorrisPratt(String where, String what) {
        int n = where.length();   //  ,    
        int m = what.length();    //  

        //   
        int[] table = new int[m];
        table[0] = 0;
        int shift = 0;
        for (int q = 1; q < m; q++) {
            while (shift > 0 && what.charAt(shift) != what.charAt(q)) {
                shift = table[shift-1];
            }
            if (what.charAt(shift) == what.charAt(q)) shift++;
            table[q] = shift;
        }

        //     
        shift = 0;
        for (int i = 0; i < n; i++) {
            while (shift > 0 && what.charAt(shift) != where.charAt(i)) {
                shift = table[shift-1];
            }
            if (what.charAt(shift) == where.charAt(i)) shift++;
            if (shift == m) return i-m+1;    //  
        }
        return -1;    //   
    }

    /**
     *  :       .
     * @param args
     */
    public static void main(String[] args) {
        int ndx = knuthMorrisPratt(Data.strWhere, Data.strWhat);
        if (ndx >= 0) {
            System.out.println("Index found: " + ndx);
            System.out.println("Substring: " + Data.strWhere.substring(ndx, ndx+Data.strWhat.length()));
        } else {
            System.out.println("Substring not found");
        }
    }
}
