
/**
 * Created by IntelliJ IDEA.
 * Author: Alexandre Koubenski
 *
 *   -     .
 * :      .
 * :         .
 *
 *  :
 *    -    (n)
 *    -         (n)
 *    -    (n)
 *
 * Date: 10.12.2005
 * Time: 17:38:58
 */
public class RabinKarp {
    // :  ,   MAXLONG / sizeof(char)
    private static long q = 36028797018963913L;

    /**
     *   -       ,
     *        
     *      .
     *
     *     -    -1.
     *
     * @param where -  ,   .
     * @param what  - ,  .
     * @return      -    -1
     */
    public static int rabinKarp(String where, String what) {
        int n = where.length();   //  ,    
        int m = what.length();    //  
        long h = 1;               //     
        for (int k = 1; k <= m-1; k++) {
            h <<= 8;
            h %= q;
        }

        long p = 0;     //    -   
        long t = 0;     //      
        for (int k = 0; k < m; k++) {
            p = ((p << 8) | (byte)what.charAt(k)) % q;
            t = ((t << 8) | (byte)where.charAt(k)) % q;
        }

        //     
        extLoop:
        for (int i = 0; i <= n-m; i++) {
            if (p == t) {
                //   ; ,     
                for (int j = 0; j < m; j++) {
                    if (where.charAt(i+j) != what.charAt(j)) {
                        //    -  
                        continue extLoop;
                    }
                }
                //  !
                return i;
            } else if (i < n-m) {
                //    
                t = (((t - h * (byte)where.charAt(i)) << 8) | (byte)where.charAt(i+m)) % q;
            }
        }
        return -1;
    }

    /**
     *  :       .
     * @param args
     */
    public static void main(String[] args) {
        int ndx = rabinKarp(Data.strWhere, Data.strWhat);
        if (ndx >= 0) {
            System.out.println("Index found: " + ndx);
            System.out.println("Substring: " + Data.strWhere.substring(ndx, ndx+Data.strWhat.length()));
        } else {
            System.out.println("Substring not found");
        }
    }
}
